package com.gxwebsoft.tower.controller;

import com.github.yulichang.wrapper.MPJLambdaWrapper;
import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.Company;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.tower.entity.*;
import com.gxwebsoft.tower.service.TowerLendingService;
import com.gxwebsoft.tower.param.TowerLendingParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 拆借管理控制器
 *
 * @author 科技小王子
 * @since 2023-06-15 10:29:54
 */
@Api(tags = "拆借管理管理")
@RestController
@RequestMapping("/api/tower/tower-lending")
public class TowerLendingController extends BaseController {
    @Resource
    private TowerLendingService towerLendingService;

    @PreAuthorize("hasAuthority('tower:towerLending:list')")
    @OperationLog
    @ApiOperation("分页查询拆借管理")
    @GetMapping("/page")
    public ApiResult<PageResult<TowerLending>> page(TowerLendingParam param) {
        MPJLambdaWrapper<TowerLending> wrapper = new MPJLambdaWrapper<>();
        wrapper.selectAll(TowerLending.class)
                .select(TowerContract::getContactNumber)
                .select(TowerContract::getSignDate)
                .select(TowerProject::getProjectName)
                .selectAs(TowerCustomer::getName, TowerCustomer::getCustomerName)
                .select(Company::getCompanyName)
                .leftJoin(TowerContract.class, TowerContract::getContractId, TowerLending::getContractId)
                .leftJoin(TowerProject.class, TowerProject::getProjectId, TowerContract::getProjectId)
                .leftJoin(TowerCustomer.class, TowerCustomer::getCustomerId, TowerContract::getCustomerId)
                .leftJoin(Company.class, Company::getCompanyId, TowerContract::getCompanyId);
        PageParam<TowerLending, TowerLendingParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(towerLendingService.page(page, wrapper));
        // 使用关联查询
        //return success(towerLendingService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerLending:list')")
    @OperationLog
    @ApiOperation("查询全部拆借管理")
    @GetMapping()
    public ApiResult<List<TowerLending>> list(TowerLendingParam param) {
        PageParam<TowerLending, TowerLendingParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(towerLendingService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(towerLendingService.listRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerLending:list')")
    @OperationLog
    @ApiOperation("根据id查询拆借管理")
    @GetMapping("/{id}")
    public ApiResult<TowerLending> get(@PathVariable("id") Integer id) {
        return success(towerLendingService.getById(id));
        // 使用关联查询
        //return success(towerLendingService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('tower:towerLending:save')")
    @OperationLog
    @ApiOperation("添加拆借管理")
    @PostMapping()
    public ApiResult<?> save(@RequestBody TowerLending towerLending) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          towerLending.setUserId(loginUser.getUserId());
        }
        if (towerLendingService.save(towerLending)) {
            return success(towerLending.getLendingId());
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerLending:update')")
    @OperationLog
    @ApiOperation("修改拆借管理")
    @PutMapping()
    public ApiResult<?> update(@RequestBody TowerLending towerLending) {
        if (towerLendingService.updateById(towerLending)) {
            return success(towerLending.getLendingId());
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerLending:remove')")
    @OperationLog
    @ApiOperation("删除拆借管理")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (towerLendingService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('tower:towerLending:save')")
    @OperationLog
    @ApiOperation("批量添加拆借管理")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<TowerLending> list) {
        if (towerLendingService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerLending:update')")
    @OperationLog
    @ApiOperation("批量修改拆借管理")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<TowerLending> batchParam) {
        if (batchParam.update(towerLendingService, "lending_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerLending:remove')")
    @OperationLog
    @ApiOperation("批量删除拆借管理")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (towerLendingService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
